Subject: bug#42147: closed (Re: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 07 Jul 2020 15:56:02 +0000

Your bug report

#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
42147: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=42147
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?
From: Mattias Engdegård <[email-masked]>
To: Andrea Corallo <[email-masked]>
Cc: [email-masked], Paul Eggert <[email-masked]>, Stefan Monnier <[email-masked]>, Andrea Corallo <[email-masked]>
Date: Tue, 7 Jul 2020 17:54:56 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

6 juli 2020 kl. 23.23 skrev Andrea Corallo <[email-masked]>:

> Yes I am happy :) Not sure about the floating point discussion
> originated from this but on my side this bug can be closed.

Then closed it is. I would happily write something in NEWS but -- as Eli noted -- for any noticeable change in behaviour to occur, many conditions need to be met, several of which are quite unlikely.

More improvements to the constant-folding are possible and desirable. For example, I have a patch that deals with constant expressions in let-bindings, so that

(let ((x (+ 1 2)))
  (f x))

simplifies to (f 3), with the variable x removed. This in turn generates more opportunities for further simplification and dead-code elimination. Tell me if you are interested.

Subject: 28.0.50; pure vs side-effect-free, missing optimizations?
From: Andrea Corallo <[email-masked]>
To: "[email-masked]" <[email-masked]>
Date: Tue, 30 Jun 2020 22:27:12 +0000 (UTC)
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi all,

I was looking in byte-opt.el to how are classified a number of
functions.

My understanding is that pure functions should be technically a subset
of side-effect-and-error-free for which the environment has no influence
on the value the function evaluates to.  For this reason they can be
constant folded in the compile time if possible.

Now in pure functions I see we do not have a lot of functions that (to
my understanding) would classify for that.  I'm thinking to simple
predicates acting on immutable objects as consp or fixnump to give an
example.

Shouldn't we move these into the pure class?

ATM for instance this does not get optimized:

(defun foo ()
  (fixnump 3))

In case this makes sense I'll be happy to work on it and prepare a
patch.

Thanks

  Andrea